<cfcomponent hint="A simple multi-factory - not thread safe">

	<cffunction name="init" access="public" output="false" returntype="factory">
		<cfset variables.registry = createObject("component", "registry").init() />
		<cfreturn this />
	</cffunction>

	<cffunction name="getService" access="public" output="false" returntype="cs_preso_2006_11_16.cfcs.service"
				hint="a singleton">
		<cfif NOT registry.has("service")>
			<cfset registry.register("service", createobject("component", "cs_preso_2006_11_16.cfcs.service").init(
					getDao()
					)) />
		</cfif>
		<cfreturn registry.get("service") />
	</cffunction>

	<cffunction name="getDao" access="public" output="false" returntype="cs_preso_2006_11_16.cfcs.dao">
		<cfif NOT registry.has("dao")>
			<cfset registry.register("dao", createobject("component", "cs_preso_2006_11_16.cfcs.dao").init(
					application.dsn
					)) />
		</cfif>
		<cfreturn registry.get("dao") />
	</cffunction>

<cfoutput></cfoutput>
</cfcomponent>